<?
include ("const.inc");
include ("common.inc");

function CART($items,$allowdelete)
{
    $output = "";          //this string will contain formated text with ordered items
                           //$output will be returned by CART function for latter sending
                           //to a shop owned and also to a customer
                                
    if ($items!="")        //if at least one item is in cart
    {
        $goods = array();               //array of items in cart
        $goods = explode("~~",$items);     //each item in CART is separated by '~~'
        $numitems = count($goods);      //number of items in cart
        $sum = 0;                               //sum of items in cart
        echo "<table width=\"98%\" cellspacing=\"0\" align=\"center\">\n";
        for ($i=0;$i<$numitems;$i++)
        {
            list( $id, $name, $price, $count) = explode(";",$goods[$i]);
            $output=$output.$id." - ".$name." - ".$price." - ".$count." ".$GLOBALS['_units']."\n";
            
            if ($i%2==1) echo "<tr><td bgcolor=\"#DDDDFF\">\n";     //odd and even items show with
            else echo "<tr><td bgcolor=\"#CCCCFF\">\n";             //different background color
            echo ($i+1).") <b>";
            echo "<a href=\"detail.php?id=".$id."\">".$name."</a></b><br/>";    //link to a detail of an item
            echo $GLOBALS['_price']." [ 1".$GLOBALS['_units']."]: <b>".$price."</b>";
            echo $GLOBALS['_currency']." <br/>".$GLOBALS['_quantity'].": <b>".$count."</b> ";
            echo $GLOBALS['_units']."<br/>";
            if ($count>1)
            {
                echo $GLOBALS['_sum'].": <b>".$price*$count."</b>".$GLOBALS['_currency'];
            }
            if ($allowdelete)		//if removing is allowed, show 'REMOVE LINK'
            {
                echo "<div align=\"center\"><a href=\"";
                echo $GLOBALS['eshop_url']."?action=delete&amp;id=".$id."\">";
                echo $GLOBALS['_remove']."</a></div>";
            }
            echo "</td></tr>\n";
            $sum=$sum+$price*$count;	//increase sum
        }
        echo "<tr><td>&nbsp;</td></tr>\n";
        echo "<tr><td bgcolor=\"#ffff33\"><font size=\"4\">";
        echo $GLOBALS['_sum'].": ".$sum.$GLOBALS['_currency']."</font></td></tr>\n";

        if ($allowdelete)		//if removing is allowed, show order and delete-all link
        {
            echo "<tr><td bgcolor=\"#FFFFFF\" align=\"center\">\n";
            echo "<b><a href=\"".$GLOBALS['eshop_url']."?action=deleteall\">";
            echo $GLOBALS['_empty_cart']."</a></b>";
            echo "</td></tr>\n";
            echo "<tr><td  bgcolor=\"#FFFFFF\"  align=\"center\">\n";
            echo "<b><a href=\"".$GLOBALS['eshop_url']."?action=order\">";
            echo $GLOBALS['_order']."</a><br/></b>";
            echo "</td></tr>\n";
        }
        echo "</table>\n";
    }
    else
    {
        echo "<b>".$GLOBALS['_cart_is_empty']."</b><br/>";
    }
    return $output;
}

//this function will process many messages sent by ACTION
//and usually will reload the page
function ProcessMessages()
{
    if (isset($_GET['action']))
    {
        if ($_GET['action']=='add')		//adding an item to cart
        {
            if (isset($_COOKIE['goods']) && $_COOKIE['goods']!="")	//if there are already some items in cart
            {														// then we will add one more
                $gd = $_COOKIE['goods'];		
                $gd = $gd."~~".$_POST['goods'];		//items are separated by '~~'
                $gd = $gd.';'.$_POST['count'];	
            }
            else
            {							// if cart is empty, add new one
                $gd = $_POST['goods'];
                $gd = $gd.";".$_POST['count'];
            }
            setcookie('goods',$gd,time()+3600);	//save to cookies and reload page
            header("Location: " . $GLOBALS['eshop_url']);
        }
        if ($_GET['action']=='deleteall')		//removing all items from cart
        {
            $gd="";
            setcookie ('goods', "", time() + 3600);		//empty cart
            header("Location: " . $GLOBALS['eshop_url']);	//reload
        }
        if ($_GET['action']=='delete')		//remove one item from cart
        {
            if (isset($_COOKIE['goods']))	//if the is something in cart
            {
                $gd = $_COOKIE['goods'];	//cart items
                $id = $_GET['id'];			//id of an item to delete
                $goods = explode('~~',$gd);	//items in cart separated by '~~'
                $numgoods = count($goods);	//number of goods in cart
                $gd="";
                	
                $j=0;			//find and delete
                for ($i=0;$i<$numgoods;$i++)
                {
                    list( $id1, $name, $price, $count) = explode(";",$goods[$i]);
                    if ($id1!=$id)
                    {
                        if ($j!=$i) $goods[$j]=$goods[$i];
                        $j++;
                    }
                }
                $goods2=array_slice($goods,0,$pocet-1); 		//shorten our array
                $zb=implode('~~',$goods2);						//implode it with '~~'
                setcookie ('goods', $zb, time() + 3600);		//save to cookies
                header("Location: " . $GLOBALS['eshop_url']);	//reload;;	
            }
        }
        if ($_GET['action']=='change')			//changes which category should be shown
        {
            setcookie ('cat', $_GET['cat'], time() + 3600);
            header("Location: " . $GLOBALS['eshop_url']);
        }
        if ($_GET['action']=='sendmail')		//send an email with an order
        {
	        //check if form is filled correctly
	        //if not, display what's wrong
            $err = CheckInputForm($_POST['name'],		
                                  $_POST['street'],
                                  $_POST['town'],
                                  $_POST['zip'],
                                  true);
            if ($err==false)	//if correct then send email
            {
                $mailtext=$GLOBALS['_porchase_order'].":\n-----------\n".$_POST['order']."\n";
                $mailtext=$mailtext.$GLOBALS['address'].":\n------\n".$_POST['name']."\n";
                $mailtext=$mailtext.$_POST['street']."\n";
                $mailtext=$mailtext.$_POST['town']."\n";
                $mailtext=$mailtext.$_POST['zip']."\n";
                $mailtext=$mailtext."\nEmail: ".$_POST['email']."\n";
                $mailtext=$mailtext.$GLOBALS['_phone']." ".$_POST['phone']."\n";
                header("Location: " . $GLOBALS['eshop_url']."?action=sent");
                mail("pausp@volny.cz",$GLOBALS['_purchase_order'],$mailtext);
                if (strlen($_POST['email'])>5)
                    mail($_POST['email'],$GLOBALS['_purchase_order'],$mailtext);
            }
        }
    }
}


//checks if order form is filled correctly
//if $silent if set to true, no errors will be shown
function CheckInputForm($name,$street,$town,$zip,$silent)
{
    $err = false;
    if (strlen($_POST['name'])<5)		//name must be at least 5 chars
    {
        $err = true;
        if ($silent==false) PrintError($GLOBALS['_bad_name']);
    }
    if (strlen($_POST['street'])<3)
    {
        $err = true;
        if ($silent==false) PrintError($GLOBALS['_bad_street']);
    }
    if (strlen($_POST['town'])<2)
    {
        $err = true;
        if ($silent==false) PrintError($GLOBALS['_bad_town']);
    }
    if (strlen($_POST['zip'])<5)
    {
        $err = true;
        if ($silent==false) PrintError($GLOBALS['_bad_ZIP']);
    }
    return $err;
}

//prints an error message
function PrintError($text)
{
    echo "<div align=\"center\"><font size=\"5\" color=\"#FF0000\">\n"; 
    echo $GLOBALS['_error'].": ".$text."<br/>\n";
    echo "</font></div>\n";
}


//shows main menu
function MENU()
{
    $filelist = array();                                    //list of files with eshop data
    $file = $GLOBALS['eshop_dir']."menu.txt";  //menu file
    $count = 0;
    
    $m = array();                   //array containing lines of menu file
    $m = LoadFile($file);       //read menu file into memory
    $count = count($m);     //number of lines in menu   (every line contains one menu item)
    
    
    for ($i=0;$i<$count;$i++)
    {
        list($type,$filename) = explode(" ",$m[$i]);        //$type can be '>' (category) or '>>' (subcategory) 
        $file = $GLOBALS['eshop_dir'].$filename;       //path and filename

        $goods  = LoadFile($file);                              //load items from file
        if ($type==">") echo "<b>";                         //is it main category
        if ($type==">>") echo '-';                              //or subcategory??
                                                                        //show link
        echo "<a href=\"".$GLOBALS['eshop_url']."?action=change&amp;cat=$filename\">\n";
        echo str_replace(';',"",$goods[0])."</a>\n<br/>";   //delete additional ';'
                                                                            //first line of a file contains name of category
        
        if ($type==">") echo "</b>";            //category was displayed in bold
        $filelist[] = $filename;                    //add filename to list of files in eshop;
    }
    echo "<br/>\n";
}

function ShowFind()             //find dialog.
{
    echo "<form method=\"post\" action=\"".$GLOBALS['eshop_url']."?action=find\">\n";
    echo "<table align=\"center\" bgcolor=\"#AAAAAA\" width=\"100%\" cellspacing=\"1\" cellpadding=\"1\">\n";
    echo "<tr><td align=\"center\">\n";
    echo "<input type=\"text\" name=\"findwhat\" value=\"\" style=\"width:50;\" size=\"23\" onfocus=\"this.select();\"><br/>";
    echo "</td></tr>";
    echo "<tr><td align=\"center\">\n";
    echo "<input type=\"checkbox\" name=\"in_name\" checked=\"on\">".$GLOBALS['_in_name']."\n";
    echo "</td></tr>";
    echo "<tr><td align=\"center\">\n";
    echo "<input type=\"checkbox\" name=\"in_desc\" checked=\"on\">".$GLOBALS['_in_desc']."\n";
    echo "</td></tr>";
    echo "<tr><td align=\"center\">\n";
    echo "<input type=\"submit\" value=\"".$GLOBALS['_find']."\" style=\"width:20;\">";
    echo "</td></tr>";
    echo "</table>\n";
    echo "</form>";
}

function ShowItem($id,$name,$price,$img,$desc)      //show item
{
    echo "<p>&nbsp;</p>\n";
    echo "<a href=\"detail.php?id=$id\">";
    echo "<img src=\"".$GLOBALS['eshop_dir'].str_replace("/","/th_",$img)."\"><br/>\n";    //thumbnails must begin with 'th_'
    echo "<b>".$name."</b></a><br/>\n".$GLOBALS['_price'].": ".$price.$GLOBALS['_currency']."<br/>";
    echo "<form method=\"post\" action=\"".$GLOBALS['eshop_url']."?action=add\">\n";
    echo "<input type=\"hidden\" name=\"goods\" value=\"$id;$name;$price\">";
    echo "<input type=\"text\" name=\"count\" value=\"1\" style=\"width:20;\" size=\"3\" onfocus=\"this.select();\"> ".$GLOBALS['_units'];
    echo "<input type=\"submit\" value=\"".$GLOBALS['_add_to_cart']."\" style=\"width:20;\">";
    echo "</form>";
}


//shows item on page
function ShowGoods($items,$cols)
{
    $count = count($items);
    echo "<table width=\"600\">\n";

    echo "<tr>\n";
    for ($i=1;$i<$count;$i++)
    {
        list( $id, $name, $prize, $img, $desc ) = explode(";",$items[$i]);
        echo "<td valign=\"bottom\" align=\"center\" width=\"200\">\n";
        
        ShowItem($id, $name, $prize, $img, $desc);
        
        echo "</td>";
        if (($i%$cols)==0)
        {
            echo "</tr>\n<tr>\n";
        }
    }
    echo "</tr></table>\n";
}


//displays a file with items
function ShowGoodsFromFile($file,$cols)
{
    $file = $GLOBALS['eshop_dir'].$file;
    $goods = array();
    $goods = LoadFile($file);
    ShowGoods($goods,$cols);
}

//order form
function OrderForm($cart)
{
    echo "<form method=\"post\" action=\"".$GLOBALS['eshop_url']."?action=sendmail\">\n";
    echo "<table width=\"400\" align=\"center\" border=\"0\">\n";
    echo "<tr>\n<td align=\"center\">\n";
    echo "<tr>\n<td>\n".$GLOBALS['_name_surname'].": </td>\n<td><input type=\"text\" name=\"name\" value=\"\" style=\"width:200;\" onfocus=\"this.select();\">*</td>\n</tr>\n";
    echo "<tr>\n<td>\n".$GLOBALS['_street'].":</td>\n<td><input type=\"text\" name=\"street\" value=\"\" style=\"width:200;\" onfocus=\"this.select();\">*</td>\n</tr>\n";
    echo "<tr>\n<td>\n".$GLOBALS['_town'].":</td>\n<td><input type=\"text\" name=\"town\" value=\"\" style=\"width:200;\" onfocus=\"this.select();\">*</td>\n</tr>\n";
    echo "<tr>\n<td>\n".$GLOBALS['_ZIP'].":</td>\n<td><input type=\"text\" name=\"zip\" value=\"\" style=\"width:200;\" onfocus=\"this.select();\">*</td>\n</tr>\n";
    echo "<tr>\n<td>\n".$GLOBALS['_email'].":</td>\n<td><input type=\"text\" name=\"email\" value=\"@\" style=\"width:200;\" onfocus=\"this.select();\"></td>\n</tr>\n";
    echo "<tr>\n<td>\n".$GLOBALS['_phone'].":</td>\n<td><input type=\"text\" name=\"phone\" value=\"+420\" style=\"width:200;\" onfocus=\"this.select();\"></td>\n</tr>\n";
    echo "<tr>\n<td>\n".$GLOBALS['_comment'].":</td>\n<td><textarea  name=\"desc\" rows=\"4\" cols=\"30\" class=\"form\"></textarea>\n</td>\n</tr>\n";
    echo "<tr>\n<td><input type=\"hidden\" name=\"order\" value=\"$cart\"></td>\n</tr>\n";
    echo "<tr><td align=\"center\"><input type=\"submit\" value=\"".$GLOBALS['_order']."\"></td>\n";
    echo "<td align=\"center\"><a href=\"".$GLOBALS['eshop_url']."\"><h3>";
    echo $GLOBALS['_continue'];
    echo "</h3></a></td></tr></table>\n</form>";
    echo "<div align=\"center\"><font color=\"#FF0000\">\n";
    echo $GLOBALS['_order_str1'];
    echo $GLOBALS['_order_str2'];
    echo "<br/><br/><b>";
    echo $GLOBALS['_order_str3'];
    echo "</b>\n";
    echo "</font></div>";
}

//shows message that email with an order was sent to show owner
function MailSent()
{
    echo "<div align=\"center\">\n";
    echo "<font color=\"#FF0000\" size=\"5\">\n";
    echo $GLOBALS['_order_sent1']."<br/>\n";
    echo $GLOBALS['_order_sent2']."<br/>\n";
    echo "</font>\n";
    echo "<br/><br/>\n";
    echo "<font size=\"4\">\n";
    echo "<a href=\"".$GLOBALS['eshop_url']."?action=deleteall\">".$GLOBALS['_back_to_shop']."</a>\n";
    echo "</font>\n";
    echo "</div>\n";
}

// finds an item in files and shows results
function FindItem($what,$in_name,$in_desc)
{
    $findarray = array();
    $found = array();
    
    $findarray = explode(" ",strtolower($what));
    $filelist = list_files($GLOBALS['eshop_dir']);
    $found[] = $GLOBALS['_found'].":";
    
    for ($i=0;$i<count($filelist);$i++)
    {
        $file = $GLOBALS['eshop_dir'].$filelist[$i];
        $goods = array();
        
        if( filesize($file) )       
        {   
            $goods = LoadFile($file);
            $count = count($goods);
            for ($j=1;$j<$count;$j++)
            {
                list( $id1, $name, $prize, $img, $desc ) = explode(";",$goods[$j]);
                
                $where = '';
                if ($in_name) $where=strtolower($name);
                if ($in_desc) $where=$where.' '.strtolower($desc);
                $ok_name=true;
                $ok_desc=true;
                for ($k=0;$k<count($findarray);$k++)
                {
                    if (strpos($where,$findarray[$k])===false)
                        $ok_name=false; 
                }
                if ($ok_name)
                {
                    $found[]=$goods[$j];
                }
            }
        }
    }
    ShowGoods($found,3);
}

?>